////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// config.cpp                                                                 //
// berwacht die Erzeugung von COM-Objekten.                                  //
// (c) 2003 c't/Matthias Withopf                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#define STRICT
#define WIN32_LEAN_AND_MEAN
#pragma warning(disable:4201)
#include <windows.h>
#include <shlwapi.h>
#pragma warning(default:4201)
#include <stdlib.h>
#include <strsafe.h>
#include "config.h"

void Str2KeyName(bool Mode,char *Str,char *KeyName,uint MaxKeyNameSize)
{
  char *p = Str;
  char *q = KeyName;
  if (!Mode)
    {
      while (*p)
        {
          char c = *p++;
          if ((int)(q - KeyName) < (int)((MaxKeyNameSize / sizeof KeyName[0]) - 2))
            {
              if (c == '\\')
                *q++ = '-';
              else if (c == '-')
                {
                  *q++ = '-';
                  *q++ = '-';
                }
              else
                *q++ = c;
            }
        }
    }
  else
    {
      while (*p)
        {
          char c = *p++;
          if ((int)(q - KeyName) < (int)((MaxKeyNameSize / sizeof KeyName[0]) - 4))
            {
              if ((c == '\\') || (c == '%'))
                {
                  char tmp[3];
                  StringCbPrintf(tmp,sizeof tmp,"%02X",c);
                  *q++ = '%';
                  *q++ = tmp[0];
                  *q++ = tmp[1];
                }
              else
                *q++ = c;
            }
        }
    }
  *q = '\0';
}

void Str2KeyNameW(bool Mode,wchar *Str,wchar *KeyName,uint MaxKeyNameSize)
{
  wchar *p = Str;
  wchar *q = KeyName;
  if (!Mode)
    {
      while (*p)
        {
          wchar c = *p++;
          if ((int)(q - KeyName) < (int)((MaxKeyNameSize / sizeof KeyName[0]) - 2))
            {
              if (c == '\\')
                *q++ = '-';
              else if (c == '-')
                {
                  *q++ = '-';
                  *q++ = '-';
                }
              else
                *q++ = c;
            }
        }
    }
  else
    {
      while (*p)
        {
          wchar c = *p++;
          if ((int)(q - KeyName) < (int)((MaxKeyNameSize / sizeof KeyName[0]) - 4))
            {
              if ((c == '\\') || (c == '%'))
                {
                  char tmp[3];
                  StringCbPrintf(tmp,sizeof tmp,"%02X",c);
                  *q++ = '%';
                  *q++ = tmp[0];
                  *q++ = tmp[1];
                }
              else
                *q++ = c;
            }
        }
    }
  *q = '\0';
}

void KeyName2Str(bool Mode,char *KeyName,char *Str,uint MaxStrSize)
{
  char *p = KeyName;
  char *q = Str;
  if (!Mode)
    {
      while (*p)
        {
          char c = *p++;
          if ((int)(q - Str) < (int)((MaxStrSize / sizeof Str[0]) - 1))
            {
              if (c == '-')
                {
                  if (p[0] == '-')
                    {
                      ++p;
                      *q++ = '-';
                    }
                  else
                    *q++ = '\\';
                }
              else
                *q++ = c;
            }
        }
    }
  else
    {
      while (*p)
        {
          char c = *p++;
          if ((int)(q - Str) < (int)((MaxStrSize / sizeof Str[0]) - 1))
            {
              if (c == '%')
                {
                  char c1,c2;
                  if (*p)
                    {
                      c1 = *p++;
                      if (*p)
                        {
                          c2 = *p++;

                          if (('0' <= c1) && (c1 <= '9'))
                            c1 = c1 - '0';
                          else if (('a' <= c1) && (c1 <= 'f'))
                            c1 = c1 - 'a' + 10;
                          else if (('A' <= c1) && (c1 <= 'F'))
                            c1 = c1 - 'A' + 10;
                          else
                            c1 = 0x03;

                          if (('0' <= c2) && (c2 <= '9'))
                            c2 = c2 - '0';
                          else if (('a' <= c2) && (c2 <= 'f'))
                            c2 = c2 - 'a' + 10;
                          else if (('A' <= c2) && (c2 <= 'F'))
                            c2 = c2 - 'A' + 10;
                          else
                            c2 = 0x0F;

                          c = (c1 << 4) | c2;
                        }
                    }
                }
              *q++ = c;
            }
        }
    }
  *q = '\0';
}

void KeyName2StrW(bool Mode,wchar *KeyName,wchar *Str,uint MaxStrSize)
{
  wchar *p = KeyName;
  wchar *q = Str;
  if (!Mode)
    {
      while (*p)
        {
          wchar c = *p++;
          if ((int)(q - Str) < (int)((MaxStrSize / sizeof Str[0]) - 1))
            {
              if (c == '-')
                {
                  if (p[0] == '-')
                    {
                      ++p;
                      *q++ = '-';
                    }
                  else
                    *q++ = '\\';
                }
              else
                *q++ = c;
            }
        }
    }
  else
    {
      while (*p)
        {
          wchar c = *p++;
          if ((int)(q - Str) < (int)((MaxStrSize / sizeof Str[0]) - 1))
            {
              if (c == '%')
                {
                  wchar c1,c2;
                  if (*p)
                    {
                      c1 = *p++;
                      if (*p)
                        {
                          c2 = *p++;

                          if (('0' <= c1) && (c1 <= '9'))
                            c1 = c1 - '0';
                          else if (('a' <= c1) && (c1 <= 'f'))
                            c1 = c1 - 'a' + 10;
                          else if (('A' <= c1) && (c1 <= 'F'))
                            c1 = c1 - 'A' + 10;
                          else
                            c1 = 0x03;

                          if (('0' <= c2) && (c2 <= '9'))
                            c2 = c2 - '0';
                          else if (('a' <= c2) && (c2 <= 'f'))
                            c2 = c2 - 'a' + 10;
                          else if (('A' <= c2) && (c2 <= 'F'))
                            c2 = c2 - 'A' + 10;
                          else
                            c2 = 0x0F;

                          c = (c1 << 4) | c2;
                        }
                    }
                }
              *q++ = c;
            }
        }
    }
  *q = '\0';
}

void Str2StrW(char *Str,wchar *StrW,uint MaxStrWSize)
{
  MaxStrWSize /= sizeof StrW[0];
  if (StrW && MaxStrWSize)
    StrW[0] = '\0';
  if (Str)
    {
      char  *p = Str;
      wchar *q = StrW;
      while (*p)
        {
          wchar c = *p++;
          if ((int)(q - StrW) < (int)(MaxStrWSize - 1))
            *q++ = c;
        }
      *q = '\0';
    }
}

void AlertMsg(char *s,bool IsInfo)
{
  MessageBox((HWND)0,s,APPNAME,MB_OK | (IsInfo ? MB_ICONINFORMATION : MB_ICONERROR) | MB_SYSTEMMODAL);
}

void AlertMsgW(wchar *s,bool IsInfo)
{
  MessageBoxW((HWND)0,s,L"",MB_OK | (IsInfo ? MB_ICONINFORMATION : MB_ICONERROR) | MB_SYSTEMMODAL);
}

class TOSLanguage
  {
  public:
    typedef enum
      {
        l_unknown,
        l_English,
        l_German,
        l_Dutch,
        l_LAST
      } TLanguage;
    static TLanguage Get(void);
  };

TOSLanguage::TLanguage TOSLanguage::Get(void)
{
  TLanguage Result = l_unknown;
  LANGID LID = GetUserDefaultLangID();
  switch(PRIMARYLANGID(LID))
    {
      default:
      case LANG_ENGLISH: Result = l_English; break;
      case LANG_GERMAN:  Result = l_German;  break;
      case LANG_DUTCH:   Result = l_Dutch;   break;
    }
  return Result;
}

void TConfig::ResLoadString(void *AppInstance,uint MsgId,char *s,uint MaxSize)
{
  if (s && MaxSize)
    s[0] = '\0';
  uint MsgId2 = MsgId;
  switch(TOSLanguage::Get())
    {
      case TOSLanguage::l_English: MsgId2 +=    0; break;
      case TOSLanguage::l_German:  MsgId2 += 1000; break;
      case TOSLanguage::l_Dutch:   MsgId2 += 2000; break;
    }
  if (!LoadString((HINSTANCE)AppInstance,MsgId2,s,MaxSize))
    if (!LoadString((HINSTANCE)AppInstance,MsgId,s,MaxSize))
      {
        if (s && MaxSize)
          StringCbCopy(s,MaxSize,"???");
      }
}

char *TConfig::ResGetDlgId(void *AppInstance,uint MsgId)
{
  uint Result = 0;
  uint MsgId2 = MsgId;
  switch(TOSLanguage::Get())
    {
      case TOSLanguage::l_English: MsgId2 +=    0; break;
      case TOSLanguage::l_German:  MsgId2 += 1000; break;
      case TOSLanguage::l_Dutch:   MsgId2 += 2000; break;
    }
  HRSRC R = FindResource((HMODULE)AppInstance,MAKEINTRESOURCE(MsgId2),RT_DIALOG);
  if (R)
    Result = MsgId2;
  else
    {
      R = FindResource((HMODULE)AppInstance,MAKEINTRESOURCE(MsgId),RT_DIALOG);
      if (R)
        Result = MsgId;
    }
  return MAKEINTRESOURCE(Result);
}

char *TConfig::ResGetMenuId(void *AppInstance,uint MenuId)
{
  uint Result = 0;
  uint MenuId2 = MenuId;
  switch(TOSLanguage::Get())
    {
      case TOSLanguage::l_English: MenuId2 +=    0; break;
      case TOSLanguage::l_German:  MenuId2 += 1000; break;
      case TOSLanguage::l_Dutch:   MenuId2 += 2000; break;
    }
  HRSRC R = FindResource((HMODULE)AppInstance,MAKEINTRESOURCE(MenuId2),RT_MENU);
  if (R)
    Result = MenuId2;
  else
    {
      R = FindResource((HMODULE)AppInstance,MAKEINTRESOURCE(MenuId),RT_DIALOG);
      if (R)
        Result = MenuId;
    }
  return MAKEINTRESOURCE(Result);
}

static char *CategoryName[TConfig::cc_LAST] =
  {
    "???",
    "CLSID",
    "Proc",
    "File",
    "INet"
  };

typedef struct _TConfigLocal
  {
    bool cl_ROConfig;
    bool cl_GlobalConfig;
    char cl_ConfigKeyName[4 * 1024];
    bool cl_ConfigRO;
    HKEY cl_ConfigKey;
    HKEY cl_ConfigKey_Category[TConfig::cc_LAST];
  } TConfigLocal,* PConfigLocal;

TConfig::TConfig(char *ConfigKeyName,char *ConfigName,bool ROConfig,bool GlobalConfig)
{
  ConfigOk = false;
  L = new TConfigLocal;
  if (L)
    {
      memset(L,0,sizeof *L);
      L->cl_ROConfig     = ROConfig;
      L->cl_GlobalConfig = GlobalConfig;
      if (ConfigKeyName && ConfigKeyName[0])
        {
          char tmp[512];
          StringCbCopy(L->cl_ConfigKeyName,sizeof L->cl_ConfigKeyName,ConfigKeyName);
          if (ConfigName && ConfigName[0])
            {
              StringCbCat(L->cl_ConfigKeyName,sizeof L->cl_ConfigKeyName,":");
              StringCbCat(L->cl_ConfigKeyName,sizeof L->cl_ConfigKeyName,ConfigName);
            }
          DWORD dw;
          LONG Result = RegCreateKeyEx(L->cl_GlobalConfig ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,L->cl_ConfigKeyName,0,0,REG_OPTION_NON_VOLATILE,KEY_CREATE_SUB_KEY | KEY_SET_VALUE | KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS,NULL,&L->cl_ConfigKey,&dw);
          if (Result == ERROR_ACCESS_DENIED)
            {
              Result = RegCreateKeyEx(L->cl_GlobalConfig ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,L->cl_ConfigKeyName,0,0,REG_OPTION_NON_VOLATILE,KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS,NULL,&L->cl_ConfigKey,&dw);
              L->cl_ConfigRO = true;
            }

          for (uint i = cc_FIRST;(Result == ERROR_SUCCESS) && (i < cc_LAST);++i)
            {
              StringCbCopy(tmp,sizeof tmp,L->cl_ConfigKeyName);
              StringCbCat(tmp,sizeof tmp,"\\");
              StringCbCat(tmp,sizeof tmp,CategoryName[i]);
              if (L->cl_ConfigRO || L->cl_ROConfig)
                Result = RegCreateKeyEx(L->cl_GlobalConfig ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,tmp,0,0,REG_OPTION_NON_VOLATILE,KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS,NULL,&L->cl_ConfigKey_Category[i],&dw);
              else
                Result = RegCreateKeyEx(L->cl_GlobalConfig ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,tmp,0,0,REG_OPTION_NON_VOLATILE,KEY_CREATE_SUB_KEY | KEY_SET_VALUE | KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS | DELETE,NULL,&L->cl_ConfigKey_Category[i],&dw);
              if (Result == ERROR_SUCCESS)
                ConfigOk = true;
            }
        }
    }
}

TConfig::~TConfig()
{
  if (L)
    {
      for (uint i = 0;i < cc_LAST;++i)
        {
          if (L->cl_ConfigKey_Category[i])
            RegCloseKey(L->cl_ConfigKey_Category[i]);
        }
      if (L->cl_ConfigKey)
        RegCloseKey(L->cl_ConfigKey);
      delete L;
    }
}

bool TConfig::Clone(char *ConfigKeyName,char *ConfigName)
{
  bool Result = false;
  if (ConfigKeyName && ConfigKeyName[0])
    {
      char NewConfigKeyName[4 * 1024];
      StringCbCopy(NewConfigKeyName,sizeof NewConfigKeyName,ConfigKeyName);
      if (ConfigName && ConfigName[0])
        {
          StringCbCat(NewConfigKeyName,sizeof NewConfigKeyName,":");
          StringCbCat(NewConfigKeyName,sizeof NewConfigKeyName,ConfigName);
        }
      HKEY  DestKey;
      DWORD dw;
      LONG L1 = RegCreateKeyEx(L->cl_GlobalConfig ? HKEY_LOCAL_MACHINE : HKEY_CURRENT_USER,NewConfigKeyName,0,0,REG_OPTION_NON_VOLATILE,KEY_CREATE_SUB_KEY | KEY_SET_VALUE | KEY_QUERY_VALUE | KEY_ENUMERATE_SUB_KEYS,NULL,&DestKey,&dw);
      if (L1 == ERROR_SUCCESS)
        {
          if (SHCopyKey(L->cl_ConfigKey,NULL,DestKey,NULL) == ERROR_SUCCESS)
            Result = true;
          RegCloseKey(DestKey);
        }
    }
  return Result;
}

void * /*HKEY*/ TConfig::GetConfigKey(TConfigType ConfigType)
{
  HKEY Result;
  switch(ConfigType)
    {
      default:
      case TConfig::ct_Default: Result = L->cl_ConfigKey; break;
    }
  return (void *)Result;
}

bool TConfig::GetIntSetting(TConfigType ConfigType,char *KeyName,uint *AValue,uint Default)
{
  bool Result = false;
  uint Value2 = Default;
  if (KeyName)
    {
      DWORD Value;
      DWORD Size = sizeof Value;
      DWORD Type;
      LONG  L1 = RegQueryValueEx((HKEY)GetConfigKey(ConfigType),KeyName,0,&Type,(BYTE *)&Value,&Size);
      if ((L1 == ERROR_SUCCESS) && (Type == REG_DWORD))
        {
          Value2 = (uint)Value;
          Result = true;
        }
    }
  if (AValue) *AValue = Value2;
  return Result;
}

bool TConfig::SetIntSetting(TConfigType ConfigType,char *KeyName,uint Value)
{
  bool Result = false;
  if (L->cl_ConfigRO || L->cl_ROConfig)
    Result = true;
  else
    {
      DWORD CurValue = Value;
      LONG L1 = RegSetValueEx((HKEY)GetConfigKey(ConfigType),KeyName,0,REG_DWORD,(BYTE *)&CurValue,sizeof CurValue);
      if (L1 != ERROR_SUCCESS)
        Result = true;
    }
  return Result;
}

bool TConfig::ListCategory(TConfigCategory ConfigCategory,uint Index,wchar *KeyName,uint MaxKeyNameSize)
{
  bool Result = false;
  if (KeyName && MaxKeyNameSize)
    KeyName[0] = '\0';
  if (L->cl_ConfigKey_Category[ConfigCategory])
    {
      DWORD dwIndex = Index;
      DWORD lpcName = MaxKeyNameSize / sizeof KeyName[0];
      if (RegEnumKeyExW(L->cl_ConfigKey_Category[ConfigCategory],dwIndex,KeyName,&lpcName,NULL,NULL,NULL,NULL) == ERROR_SUCCESS)
        Result = true;
    }
  return Result;
}

static char *Key_Type     = "Type";
static char *Key_Disabled = "Disabled";
static char *Key_State    = "State";
static char *Key_Descr    = "Descr";

bool TConfig::GetCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW,uint *Type,uint *Disabled,uint *State,char *Descr,uint MaxDescrSize)
{
  bool Result = false;
  if (Type)                 *Type     = 0;
  if (Disabled)             *Disabled = false;
  if (State)                *State    = 0;
  if (Descr && MaxDescrSize) Descr[0] = '\0';
  if (L->cl_ConfigKey_Category[ConfigCategory])
    {
      HKEY Key;
      LONG L1;
      if (KeyNameW)
        L1 = RegOpenKeyExW(L->cl_ConfigKey_Category[ConfigCategory],KeyNameW,0,KEY_QUERY_VALUE,&Key);
      else
        L1 = RegOpenKeyEx(L->cl_ConfigKey_Category[ConfigCategory],KeyName,0,KEY_QUERY_VALUE,&Key);
      if (L1 == ERROR_SUCCESS)
        {
          Result = true;

          DWORD RegType;
          DWORD Value;
          DWORD Size = sizeof Value;
          L1 = RegQueryValueEx(Key,Key_Type,0,&RegType,(BYTE *)&Value,&Size);
          if ((L1 == ERROR_SUCCESS) && (RegType == REG_DWORD))
            if (Type)
              *Type = Value;
          Size = sizeof Value;
          L1 = RegQueryValueEx(Key,Key_Disabled,0,&RegType,(BYTE *)&Value,&Size);
          if ((L1 == ERROR_SUCCESS) && (RegType == REG_DWORD))
            if (Disabled)
              *Disabled = Value;
          Size = sizeof Value;
          L1 = RegQueryValueEx(Key,Key_State,0,&RegType,(BYTE *)&Value,&Size);
          if ((L1 == ERROR_SUCCESS) && (RegType == REG_DWORD))
            if (State)
              *State = Value;
          if (Descr)
            {
              Size = MaxDescrSize;
              L1 = RegQueryValueEx(Key,Key_Descr,0,&RegType,(BYTE *)Descr,&Size);
              if ((L1 == ERROR_SUCCESS) && (RegType == REG_SZ))
                {
                }
            }
          RegCloseKey(Key);
        }
    }
  return Result;
}

bool TConfig::SetCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW,bool ValidType,uint Type,bool ValidDisabled,uint Disabled,bool ValidState,uint State,bool ValidDescr,char *Descr)
{
  bool Result = false;
  if (L->cl_ConfigKey_Category[ConfigCategory])
    {
      if (L->cl_ConfigRO || L->cl_ROConfig)
        Result = true;
      else
        {
          HKEY Key;
          DWORD dw;
          LONG L1;
          if (KeyNameW)
            L1 = RegCreateKeyExW(L->cl_ConfigKey_Category[ConfigCategory],KeyNameW,0,0,REG_OPTION_NON_VOLATILE,KEY_SET_VALUE,NULL,&Key,&dw);
          else
            L1 = RegCreateKeyEx(L->cl_ConfigKey_Category[ConfigCategory],KeyName,0,0,REG_OPTION_NON_VOLATILE,KEY_SET_VALUE,NULL,&Key,&dw);
          if (L1 == ERROR_SUCCESS)
            {
              Result = true;
              DWORD CurValue;
              if (ValidType)
                {
                  CurValue = Type;
                  L1 = RegSetValueEx(Key,Key_Type,0,REG_DWORD,(BYTE *)&CurValue,sizeof CurValue);
                }
              if (ValidDisabled)
                {
                  CurValue = Disabled;
                  L1 = RegSetValueEx(Key,Key_Disabled,0,REG_DWORD,(BYTE *)&CurValue,sizeof CurValue);
                }
              if (ValidState)
                {
                  CurValue = State;
                  L1 = RegSetValueEx(Key,Key_State,0,REG_DWORD,(BYTE *)&CurValue,sizeof CurValue);
                }
              if (ValidDescr)
                {
                  if (Descr)
                    L1 = RegSetValueEx(Key,Key_Descr,0,REG_SZ,(BYTE *)Descr,strlen(Descr) + 1);
                }
              RegCloseKey(Key);
            }
        }
    }
  return Result;
}

bool TConfig::DeleteCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW)
{
  bool Result = false;
  if (L->cl_ConfigKey_Category[ConfigCategory])
    {
      if (L->cl_ConfigRO || L->cl_ROConfig)
        Result = true;
      else
        {
          if ((KeyName && KeyName[0]) || (KeyNameW && KeyNameW[0]))
            {
              LONG L1;
              if (KeyNameW)
                L1 = SHDeleteKeyW(L->cl_ConfigKey_Category[ConfigCategory],KeyNameW);
              else
                L1 = SHDeleteKey(L->cl_ConfigKey_Category[ConfigCategory],KeyName);
              if (L1 == ERROR_SUCCESS)
                Result = true;
            }
        }
    }
  return Result;
}

static char *Key_DefaultsSet               = "DefaultsSet";
static char *Key_COMDefaultAction          = "COMDefaultAction";
static char *Key_AppDefaultAction          = "AppDefaultAction";
static char *Key_FileDefaultAction         = "FileDefaultAction";
static char *Key_INetDefaultAction         = "INetDefaultAction";
static char *Key_AllowedIEDefaults         = "AllowedIEDefaults";
static char *Key_AllowedJScript            = "AllowedJScript";
static char *Key_AllowedVBScript           = "AllowedVBScript";
static char *Key_AllowedJava               = "AllowedJava";
static char *Key_AllowedAcrobatReader      = "AllowedAcrobatReader";
static char *Key_AllowedFlash              = "AllowedFlash";
static char *Key_AllowedPNG                = "AllowedPNG";
static char *Key_AllowedServerRelLinks     = "AllowedServerRelLinks";
static char *Key_AllowedServerAds          = "AllowedServerAds";
static char *Key_AllowedProcNotepad        = "AllowedProcNotepad";
static char *Key_AllowedProcWMPlayer       = "AllowedProcWMPlayer";
static char *Key_AllowedProcAcroRd32       = "AllowedProcAcroRd32";
static char *Key_AllowedProcRealPlayer     = "AllowedProcRealPlayer";
static char *Key_AllowedProcWord           = "AllowedProcWord";
static char *Key_AllowedProcExcel          = "AllowedProcExcel";
static char *Key_AllowedProcPowerPoint     = "AllowedProcPowerPoint";
static char *Key_AllowedFileSystemRead     = "AllowedFileSystemRead";
static char *Key_AllowedFileBrowserCache   = "AllowedFileBrowserCache";
static char *Key_AllowedFileBrowserHistory = "AllowedFileBrowserHistory";
static char *Key_AllowedFileTemp           = "AllowedFileTemp";
static char *Key_AllowedFileCookies        = "AllowedFileCookies";
static char *Key_AllowedFileDesktop        = "AllowedFileDesktop";
static char *Key_AllowedFileFavorites      = "AllowedFileFavorites";
static char *Key_AllowedIP                 = "AllowedIP";
static char *Key_DisableVeriSign           = "DisableVeriSign";
static char *Key_LogData                   = "LogData";
static char *Key_LogAll                    = "LogAll";
static char *Key_LogDisabled               = "LogDisabled";

static char *GetKey(TConfig::TSettingType SettingType)
{
  char *Result = NULL;
  switch(SettingType)
    {
      case TConfig::st_DefaultsSet:               Result = Key_DefaultsSet;               break;
      case TConfig::st_COMDefaultAction:          Result = Key_COMDefaultAction;          break;
      case TConfig::st_AppDefaultAction:          Result = Key_AppDefaultAction;          break;
      case TConfig::st_FileDefaultAction:         Result = Key_FileDefaultAction;         break;
      case TConfig::st_INetDefaultAction:         Result = Key_INetDefaultAction;         break;
      case TConfig::st_AllowedIEDefaults:         Result = Key_AllowedIEDefaults;         break;
      case TConfig::st_AllowedJScript:            Result = Key_AllowedJScript;            break;
      case TConfig::st_AllowedVBScript:           Result = Key_AllowedVBScript;           break;
      case TConfig::st_AllowedJava:               Result = Key_AllowedJava;               break;
      case TConfig::st_AllowedAcrobatReader:      Result = Key_AllowedAcrobatReader;      break;
      case TConfig::st_AllowedFlash:              Result = Key_AllowedFlash;              break;
      case TConfig::st_AllowedPNG:                Result = Key_AllowedPNG;                break;
      case TConfig::st_AllowedServerRelLinks:     Result = Key_AllowedServerRelLinks;     break;
      case TConfig::st_AllowedServerAds:          Result = Key_AllowedServerAds;          break;
      case TConfig::st_AllowedProcNotepad:        Result = Key_AllowedProcNotepad;        break;
      case TConfig::st_AllowedProcWMPlayer:       Result = Key_AllowedProcWMPlayer;       break;
      case TConfig::st_AllowedProcAcroRd32:       Result = Key_AllowedProcAcroRd32;       break;
      case TConfig::st_AllowedProcRealPlayer:     Result = Key_AllowedProcRealPlayer;     break;
      case TConfig::st_AllowedProcWord:           Result = Key_AllowedProcWord;           break;
      case TConfig::st_AllowedProcExcel:          Result = Key_AllowedProcExcel;          break;
      case TConfig::st_AllowedProcPowerPoint:     Result = Key_AllowedProcPowerPoint;     break;
      case TConfig::st_AllowedFileSystemRead:     Result = Key_AllowedFileSystemRead;     break;
      case TConfig::st_AllowedFileBrowserCache:   Result = Key_AllowedFileBrowserCache;   break;
      case TConfig::st_AllowedFileBrowserHistory: Result = Key_AllowedFileBrowserHistory; break;
      case TConfig::st_AllowedFileTemp:           Result = Key_AllowedFileTemp;           break;
      case TConfig::st_AllowedFileCookies:        Result = Key_AllowedFileCookies;        break;
      case TConfig::st_AllowedFileDesktop:        Result = Key_AllowedFileDesktop;        break;
      case TConfig::st_AllowedFileFavorites:      Result = Key_AllowedFileFavorites;      break;
      case TConfig::st_AllowedIP:                 Result = Key_AllowedIP;                 break;
      case TConfig::st_DisableVeriSign:           Result = Key_DisableVeriSign;           break;
      case TConfig::st_LogData:                   Result = Key_LogData;                   break;
      case TConfig::st_LogAll:                    Result = Key_LogAll;                    break;
      case TConfig::st_LogDisabled:               Result = Key_LogDisabled;               break;
    }
  return Result;
}

uint TConfig::GetGlobalSetting(TSettingType SettingType,uint Default)
{
  uint Result = Default;
  char *Key = GetKey(SettingType);
  if (Key)
    GetIntSetting(ct_Default,Key,&Result,Default);
  return Result;
}

void TConfig::SetGlobalSetting(TSettingType SettingType,uint Value)
{
  char *Key = GetKey(SettingType);
  if (Key)
    SetIntSetting(ct_Default,Key,Value);
}

bool TConfig::GetRegistryClassesRoot(char *KeyName,char *ValueName,char *Value,uint MaxValueSize)
{
  bool Result = false;
  HKEY Key;
  LONG L = RegOpenKeyEx(HKEY_CLASSES_ROOT,KeyName,0,KEY_QUERY_VALUE,&Key);
  if (L == ERROR_SUCCESS)
    {
      DWORD Type;
      DWORD Size = MaxValueSize;
      L = RegQueryValueEx(Key,ValueName,0,&Type,(BYTE *)Value,&Size);
      RegCloseKey(Key);
      if (L == ERROR_SUCCESS)
        {
          if (Type == REG_SZ)
            Result = true;
          else if (Type == REG_EXPAND_SZ)
            {
              char tmp[4 * 1024];
              StringCbCopy(tmp,sizeof tmp,Value);
              ExpandEnvironmentStrings(tmp,Value,MaxValueSize);
              Result = true;
            }
        }
    }
  return Result;
}

bool TConfig::CLSID2Str(void *ClassID,char *s,uint MaxSize,uint Mode)
{
  bool Result = false;
  if (ClassID)
    {
      CLSID *CID = (CLSID *)ClassID;
      char tmp[80];
      StringCbPrintf(tmp,sizeof tmp,"%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X",CID->Data1,CID->Data2,CID->Data3,CID->Data4[0],CID->Data4[1],CID->Data4[2],CID->Data4[3],CID->Data4[4],CID->Data4[5],CID->Data4[6],CID->Data4[7]);
      if (Mode == 1)
        {
          char tmp1[128];
          StringCbPrintf(tmp1,sizeof tmp1,"CLSID\\{%s}",tmp);
          StringCbCopy(s,MaxSize,tmp1);
        }
      else
        StringCbCopy(s,MaxSize,tmp);
      Result = true;
    }
  return Result;
}

bool GetAppPath(char *AppName,wchar *FileName,uint MaxFileNameSize)
{
  bool Result = false;
  if (FileName && MaxFileNameSize)
    FileName[0] = '\0';
  if (AppName && AppName[0])
    {
      char  tmp[1024];
      wchar tmp1[1024],tmp2[1024];
      StringCbCopy(tmp,sizeof tmp,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\");
      StringCbCat(tmp,sizeof tmp,AppName);

      HKEY Key = 0;
      if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,tmp,0,KEY_QUERY_VALUE,&Key) == ERROR_SUCCESS)
        {
          DWORD ValueType;
          DWORD ValueSize = sizeof tmp1;
          if (RegQueryValueExW(Key,L"",NULL,&ValueType,(LPBYTE)tmp1,&ValueSize) == ERROR_SUCCESS)
            if (ValueType == REG_SZ)
              {
                StringCbCopyW(FileName,MaxFileNameSize * sizeof FileName[0],tmp1);
                Result = true;
              }
            else if (ValueType == REG_EXPAND_SZ)
              {
                if (ExpandEnvironmentStringsW(tmp1,tmp2,sizeof tmp2 / sizeof tmp2[0]))
                  {
                    StringCbCopyW(FileName,MaxFileNameSize * sizeof FileName[0],tmp2);
                    Result = true;
                  }
                else
                  {
                    StringCbCopyW(FileName,MaxFileNameSize * sizeof FileName[0],tmp1);
                    Result = true;
                  }
              }
          RegCloseKey(Key);
        }
    }
  return Result;
}

bool GetBrowserExecutableName(char *BrowserFileName,uint MaxBrowserFileNameSize)
{
  bool Result = false;
  char ExecutableName[1024];
  ExecutableName[0] = '\0';
  char tmp1[1024];

  if (!Result)
    {
      HKEY Key = 0;
      if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\IEXPLORE.EXE",0,KEY_QUERY_VALUE,&Key) == ERROR_SUCCESS)
        {
          DWORD ValueType;
          DWORD ValueSize = sizeof tmp1;
          if (RegQueryValueEx(Key,"",NULL,&ValueType,(LPBYTE)tmp1,&ValueSize) == ERROR_SUCCESS)
            if (ValueType == REG_SZ)
              {
                StringCbCopy(BrowserFileName,MaxBrowserFileNameSize,tmp1);
                Result = true;
              }
          RegCloseKey(Key);
        }
    }

  if (!Result)
    {
      char tmp3[256];
      StringCbCopy(tmp3,sizeof tmp3,"SOFTWARE\\Classes\\");
      StringCbCat(tmp3,sizeof tmp3,".htm");
      HKEY Key = 0;
      if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,tmp3,0,KEY_QUERY_VALUE,&Key) == ERROR_SUCCESS)
        {
          DWORD ValueType;
          DWORD ValueSize = sizeof tmp1;
          if (RegQueryValueEx(Key,"",NULL,&ValueType,(LPBYTE)tmp1,&ValueSize) == ERROR_SUCCESS)
            if (ValueType == REG_SZ)
              {
                char tmp2[256];
                StringCbCopy(tmp2,sizeof tmp2,"SOFTWARE\\Classes\\");
                StringCbCat(tmp2,sizeof tmp2,tmp1);
                StringCbCat(tmp2,sizeof tmp2,"\\shell\\open\\command");
                HKEY Key1 = 0;
                if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,tmp2,0,KEY_QUERY_VALUE,&Key1) == ERROR_SUCCESS)
                  {
                    ValueSize = sizeof tmp1;
                    if (RegQueryValueEx(Key1,"",NULL,&ValueType,(LPBYTE)tmp1,&ValueSize) == ERROR_SUCCESS)
                      {
                        switch(ValueType)
                          {
                            case REG_SZ:
                              StringCbCopy(ExecutableName,sizeof ExecutableName,tmp1);
                              break;

                            case REG_EXPAND_SZ:
                              if (!ExpandEnvironmentStrings(tmp1,ExecutableName,sizeof ExecutableName))
                                ExecutableName[0] = '\0';
                              break;
                          }
                      }
                    RegCloseKey(Key1);
                  }
              }
          RegCloseKey(Key);
        }

      if (ExecutableName[0])
        {
          char *p = ExecutableName;
          if (*p == '"')
            {
              ++p;
              bool WithinQuote = true;
              for (;*p;++p)
                {
                  if (*p == '"')
                    WithinQuote = !WithinQuote;
                  else if (*p == ' ')
                    {
                      if (!WithinQuote)
                        break;
                    }
                }
              *p = '\0';
              uint l = strlen(ExecutableName);
              if (l > 0)
                if (ExecutableName[l - 1] == '"')
                  ExecutableName[l - 1] = '\0';
              StringCbCopy(BrowserFileName,MaxBrowserFileNameSize,ExecutableName + 1);
            }
          else
            {
              while (*p && (*p != ' '))
                ++p;
              *p = '\0';
              StringCbCopy(BrowserFileName,MaxBrowserFileNameSize,ExecutableName);
            }
          Result = true;
        }
    }

  return Result;
}


typedef struct
  {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
  } UNICODE_STRING;
typedef struct
  {
    ULONG           oa_Length;
    HANDLE          oa_RootDirectory;
    UNICODE_STRING *oa_ObjectName;
    ULONG           oa_Attributes;
    PVOID           oa_SecurityDescriptor;
    PVOID           oa_SecurityQualityOfService;
  } TObjectAttributes,* PObjectAttributes;
typedef struct
  {
    DWORD Status;
    DWORD Information;
  } TIOStatusBlock,* PIOStatusBlock;
typedef struct
  {
    DWORD         F1[2];
    LARGE_INTEGER F2[6];
    DWORD         F3[3];
    BYTE          AlternateNameLen;
    BYTE          Pad;
    WCHAR         AlternateName[12];
    WCHAR         FileName[260];
  } TFileBothDirectoryInfo;

typedef DWORD (__stdcall *TNtOpenFile)          (PDWORD Handle,DWORD Access,PObjectAttributes OA,PIOStatusBlock SB,DWORD ShareAccess,DWORD OpenOptions);
typedef DWORD (__stdcall *TNtQueryDirectoryFile)(DWORD Handle,DWORD Event,PVOID ApcFunc,PVOID ApcContext,PIOStatusBlock IoStatusBlock,PVOID Info,DWORD InfoSize,DWORD InfoClass,DWORD SingleEntry,UNICODE_STRING *FileName,DWORD Restart);
typedef DWORD (__stdcall *TNtClose)             (DWORD Handle);

TNtOpenFile           OrigNtOpenFileFunc           = NULL;
TNtQueryDirectoryFile OrigNtQueryDirectoryFileFunc = NULL;
TNtClose              OrigNtCloseFunc              = NULL;

bool InitFileNameEqFuncs(void)
{
  bool Result = false;
  static bool Inited = false;
  if (Inited)
    Result = true;
  else
    {
      HMODULE NtDll = GetModuleHandle("ntdll.dll");
      if (NtDll)
        {
          OrigNtOpenFileFunc           = (TNtOpenFile)          GetProcAddress(NtDll,"NtOpenFile");
          OrigNtQueryDirectoryFileFunc = (TNtQueryDirectoryFile)GetProcAddress(NtDll,"NtQueryDirectoryFile");
          OrigNtCloseFunc              = (TNtClose)             GetProcAddress(NtDll,"NtClose");

          const uint CodeSize = 1024;
          LPVOID A = VirtualAlloc(NULL,CodeSize,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
          if (A)
            {
              memcpy(A,OrigNtOpenFileFunc,CodeSize);
              DWORD P;
              VirtualProtect(A,CodeSize,PAGE_EXECUTE_READ,&P);
              OrigNtOpenFileFunc = (TNtOpenFile)A;
            }

          if (OrigNtOpenFileFunc && OrigNtQueryDirectoryFileFunc && OrigNtCloseFunc)
            {
              Inited = true;
              Result = true;
            }
        }
    }
  return Result;
}

bool FileNamesEq(wchar *FN1,wchar *FN2,bool f,bool f2)
{
  bool Result = false;
  __try
    {
      if (FN1 && FN1[0] && FN2 && FN2[0])
        {
          UINT OldErrorMode = SetErrorMode(SEM_NOOPENFILEERRORBOX | SEM_FAILCRITICALERRORS);

          const uint TmpSize = 4 * 1024;
          WCHAR tmp1[TmpSize + 1],tmp2[TmpSize + 1];
          PWCHAR p1 = FN1;
          PWCHAR p2 = FN2;
          PWCHAR p3 = tmp1;
          PWCHAR p4 = tmp2;

          for (uint Pass = 0;Pass < 2;++Pass)
            {
              PWCHAR ps,pd,tmp;
              if (!Pass)
                { ps  = p1; pd  = p3; tmp = tmp1; }
              else
                { ps  = p2; pd  = p4; tmp = tmp2; }

              *pd++ = '\\'; *pd++ = '?'; *pd++ = '?'; *pd++ = '\\';

              if (((('a' <= ps[0]) && (ps[0] <= 'z')) || (('A' <= ps[0]) && (ps[0] <= 'Z'))) && (ps[1] == ':') && (ps[2] == '\\'))
                {
                  *pd++ = *ps++; *pd++ = *ps++; *pd++ = *ps++;
                }
              else if ((ps[0] == '\\') && (ps[1] == '\\'))
                {
                  *pd++ = 'U'; *pd++ = 'N'; *pd++ = 'C';
                  ++ps;
                  *pd++ = *ps++;
                  while (*ps && (*ps != '\\') && ((pd - tmp) < TmpSize))
                    *pd++ = *ps++;
                  if (*ps && ((pd - tmp) < TmpSize))
                    *pd++ = *ps++;
                  while (*ps && (*ps != '\\') && ((pd - tmp) < TmpSize))
                    *pd++ = *ps++;
                  if (*ps && ((pd - tmp) < TmpSize))
                    *pd++ = *ps++;
                }
              *pd = '\0';

              if (!Pass)
                { p1 = ps; p3 = pd; }
              else
                { p2 = ps; p4 = pd; }
            }


          if (CompareStringW(LOCALE_USER_DEFAULT,NORM_IGNORECASE,(LPCWSTR)tmp1,(DWORD)-1,(LPCWSTR)tmp2,(DWORD)-1) == 2/*CSTR_EQUAL*/)
            {
              for (;;)
                {
                  if (!*p1 && !*p2)
                    {
                      Result = true;
                      break;
                    }
                  else if (!*p1)
                    {
                      break;
                    }
                  else if (!*p2)
                    {
                      if (f)
                        Result = true;
                      break;
                    }

                  const uint MaxShortNameSize = 260;
                  WCHAR ShortName1[MaxShortNameSize + 1],ShortName2[MaxShortNameSize + 1];
                  for (uint Pass = 0;Pass < 2;++Pass)
                    {
                      PWCHAR ps,pd,tmp,ShortName;
                      if (!Pass)
                        { ps  = p1; pd  = p3; tmp = tmp1; ShortName = ShortName1; }
                      else
                        { ps  = p2; pd  = p4; tmp = tmp2; ShortName = ShortName2; }
                      PWCHAR px = pd;

                      while (*ps && (*ps != '\\') && ((pd - tmp) < TmpSize))
                        *pd++ = *ps++;
                      *pd = '\0';

                      uint l = (px - tmp) * sizeof px[0];
                      const DWORD Access = 0x00100001;
                      UNICODE_STRING US;
                      US.Length        = (USHORT)l;
                      US.MaximumLength = US.Length;
                      US.Buffer        = (PWSTR)tmp;
                      TObjectAttributes OA;
                      OA.oa_Length                   = sizeof OA;
                      OA.oa_RootDirectory            = NULL;
                      OA.oa_ObjectName               = &US;
                      OA.oa_Attributes               = 0x0040;
                      OA.oa_SecurityDescriptor       = NULL;
                      OA.oa_SecurityQualityOfService = NULL;
                      TIOStatusBlock SB;

                      const DWORD ShareAccess = 0x0007;
                      const DWORD OpenOptions = 0x4021;

                      bool IsOk = false;
                      DWORD Handle;
                      DWORD StatusCode = OrigNtOpenFileFunc(&Handle,Access,&OA,&SB,ShareAccess,OpenOptions);
                      if (!StatusCode)
                        {
                          uint l = lstrlenW(px);
                          UNICODE_STRING US;
                          US.Length        = (USHORT)(l * sizeof px[0]);
                          US.MaximumLength = US.Length;
                          US.Buffer        = (PWSTR)px;
                          TFileBothDirectoryInfo FileBothDirectoryInfo;
                          StatusCode = OrigNtQueryDirectoryFileFunc(Handle,0,NULL,NULL,&SB,&FileBothDirectoryInfo,sizeof FileBothDirectoryInfo,3,true,&US,true);
                          if (!StatusCode && FileBothDirectoryInfo.AlternateNameLen)
                            {
                              memcpy(ShortName,FileBothDirectoryInfo.AlternateName,FileBothDirectoryInfo.AlternateNameLen);
                              ShortName[FileBothDirectoryInfo.AlternateNameLen / sizeof ShortName[0]] = '\0';
                              IsOk = true;
                            }
                          OrigNtCloseFunc(Handle);
                        }
                      if (!IsOk)
                        {
                          uint l = lstrlenW(px);
                          if (l > MaxShortNameSize)
                            l = MaxShortNameSize;
                          memcpy(ShortName,px,l * sizeof ShortName[0]);
                          ShortName[l] = '\0';
                        }

                      if (*ps)
                        *pd++ = *ps++;

                      if (!Pass)
                        { p1 = ps; p3 = pd; }
                      else
                        { p2 = ps; p4 = pd; }
                    }
                  if (CompareStringW(LOCALE_USER_DEFAULT,NORM_IGNORECASE,(LPCWSTR)ShortName1,(DWORD)-1,(LPCWSTR)ShortName2,(DWORD)-1) != 2/*CSTR_EQUAL*/)
                    break;
                }
            }
          SetErrorMode(OldErrorMode);
        }
    }
  __except(EXCEPTION_EXECUTE_HANDLER)
    {
      Result = false;
    }
  return Result;
}

