////////////////////////////////////////////////////////////////////////////////
//                                                                            //
// config.h                                                                   //
// berwacht die Erzeugung von COM-Objekten.                                  //
// (c) 2003 c't/Matthias Withopf                                              //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

#ifndef _CONFIG_H_
#define _CONFIG_H_

#define APPNAME           "c't-IEController 2.0  2003 c't/Matthias Withopf, wit@heise.de"

typedef unsigned int       uint;
typedef unsigned short int wchar;

typedef enum
  {
    lt_unknown,
    lt_BlackList,
    lt_WhiteList,
    lt_LAST
  } TListType;

void Str2KeyName(bool Mode,char *Str,char *KeyName,uint MaxKeyNameSize);
void Str2KeyNameW(bool Mode,wchar *Str,wchar *KeyName,uint MaxKeyNameSize);

void KeyName2Str(bool Mode,char *KeyName,char *Str,uint MaxStrSize);
void KeyName2StrW(bool Mode,wchar *KeyName,wchar *Str,uint MaxStrSize);

void Str2StrW(char *Str,wchar *StrW,uint MaxStrWSize);

void AlertMsg(char *s,bool IsInfo = false);
void AlertMsgW(wchar *s,bool IsInfo = false);

struct _TConfigLocal;
class TConfig
  {
  public:
    bool ConfigOk;
    TConfig(char *ConfigKeyName,char *ConfigName,bool ROConfig,bool GlobalConfig);
    ~TConfig();
    bool Clone(char *ConfigKeyName,char *ConfigName);
    typedef enum
      {
        ct_Default,
        ct_LAST
      } TConfigType;
    bool GetIntSetting(TConfigType ConfigType,char *KeyName,uint *Value,uint Default);
    bool SetIntSetting(TConfigType ConfigType,char *KeyName,uint Value);
    typedef enum
      {
        cc_unknown,
        cc_FIRST,
        cc_CLSID = cc_FIRST,
        cc_Process,
        cc_File,
        cc_INet,
        cc_LAST
      } TConfigCategory;
    bool ListCategory(TConfigCategory ConfigCategory,uint Index,wchar *KeyName,uint MaxKeyNameSize);
    bool GetCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW,uint *Type,uint *Disabled,uint *State,char *Descr,uint MaxDescrSize);
    bool SetCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW,bool ValidType,uint Type,bool ValidDisabled,uint Disabled,bool ValidState,uint State,bool ValidDescr,char *Descr);
    bool DeleteCategorySetting(TConfigCategory ConfigCategory,char *KeyName,wchar *KeyNameW);
    typedef enum
      {
        st_unknown,
        st_DefaultsSet,
        st_COMDefaultAction,
        st_AppDefaultAction,
        st_FileDefaultAction,
        st_INetDefaultAction,
        st_AllowedIEDefaults,
        st_AllowedJScript,
        st_AllowedVBScript,
        st_AllowedJava,
        st_AllowedAcrobatReader,
        st_AllowedFlash,
        st_AllowedPNG,
        st_AllowedServerRelLinks,
        st_AllowedServerAds,
        st_AllowedProcNotepad,
        st_AllowedProcWMPlayer,
        st_AllowedProcAcroRd32,
        st_AllowedProcRealPlayer,
        st_AllowedProcWord,
        st_AllowedProcExcel,
        st_AllowedProcPowerPoint,
        st_AllowedFileSystemRead,
        st_AllowedFileBrowserCache,
        st_AllowedFileBrowserHistory,
        st_AllowedFileTemp,
        st_AllowedFileCookies,
        st_AllowedFileDesktop,
        st_AllowedFileFavorites,
        st_AllowedIP,
        st_DisableVeriSign,
        st_LogData,
        st_LogAll,
        st_LogDisabled,
        st_LAST
      } TSettingType;
    uint GetGlobalSetting(TSettingType SettingType,uint Default);
    void SetGlobalSetting(TSettingType SettingType,uint Value);
    static bool  GetRegistryClassesRoot(char *KeyName,char *ValueName,char *Value,uint MaxValueSize);
    static bool  CLSID2Str(void *ClassID,char *s,uint MaxSize,uint Mode);
    static void  ResLoadString(void *AppInstance,uint MsgId,char *s,uint MaxSize);
    static char *ResGetDlgId(void *AppInstance,uint MsgId);
    static char *ResGetMenuId(void *AppInstance,uint MenuId);
  private:
    struct _TConfigLocal *L;
    void * /*HKEY*/ TConfig::GetConfigKey(TConfigType ConfigType);
  };
typedef TConfig * PConfig;

bool GetAppPath(char *AppName,wchar *FileName,uint MaxFileNameSize);
bool GetBrowserExecutableName(char *BrowserFileName,uint MaxBrowserFileNameSize);

bool InitFileNameEqFuncs(void);
bool FileNamesEq(wchar *FN1,wchar *FN2,bool f = false,bool f2 = false);

#endif

